Index: tests/regressiontests/admin_listcolumn/tests.py
===================================================================
--- tests/regressiontests/admin_listcolumn/tests.py	(revision 0)
+++ tests/regressiontests/admin_listcolumn/tests.py	(revision 0)
@@ -0,0 +1,223 @@
+"""
+This file demonstrates two different styles of tests (one doctest and one
+unittest). These will both pass when you run "manage.py test".
+
+Replace these with more appropriate tests for your application.
+"""
+from django.test import TestCase
+
+
+ADMIN_PFX = '/admin_listcolumn/admin/admin_listcolumn'
+
+
+class login(object):
+    def __init__(self, testcase, user, password):
+        self.testcase = testcase
+        success = testcase.client.login(username=user, password=password)
+        self.testcase.assertTrue(
+            success,
+            "login with username=%r, password=%r failed" % (user, password)
+        )
+
+    def __enter__(self):
+        pass
+
+    def __exit__(self, *args):
+        self.testcase.client.logout()
+
+
+class BaseCustomizationTest(TestCase):
+    """Base class for admin changelist customization test cases"""
+
+    fixtures = ['listcolumn.json']
+
+    def _get_page(self):
+        with login(self, 'root', '123'):
+            return self.client.get(self.changelist_url)
+
+
+class ModelMethodCustomizationTest(BaseCustomizationTest):
+    """Test old way to admin customization"""
+
+    def setUp(self):
+        self.changelist_url = '%s/topic/' % ADMIN_PFX
+
+    def test_short_description(self):
+        request = self._get_page()
+        self.assertEqual(request.content.count('''<th>
+
+Replies count
+</th>'''), 2)
+
+    def test_allow_tags(self):
+        request = self._get_page()
+        self.assertEqual(request.content.count('<td><i>0</i></td>'), 1)
+        self.assertEqual(request.content.count('<td><i>1</i></td>'), 12)
+        self.assertEqual(request.content.count('<td><i>2</i></td>'), 11)
+        self.assertEqual(request.content.count('<td><i>3</i></td>'), 4)
+        self.assertEqual(request.content.count('<td><strong>4</strong></td>'), 6)
+        self.assertEqual(request.content.count('<td><strong>5</strong></td>'), 6)
+
+    def test_boolean(self):
+        request = self._get_page()
+        self.assertEqual(request.content.count('<td><img src="/media/img/admin/icon-yes.gif" alt="True" /></td>'), 39)
+        self.assertEqual(request.content.count('<td><img src="/media/img/admin/icon-no.gif" alt="False" /></td>'), 1)
+
+    def test_admin_order_field(self):
+        with login(self, 'root', '123'):
+            request = self.client.get(self.changelist_url)
+            self.assertContains(request, '''<th>
+<a href="?ot=asc&amp;o=6">
+Is staff
+</a></th>''')
+            request = self.client.get(self.changelist_url + '?ot=asc&o=6')
+            self.assertContains(request, '''<th class="sorted ascending">
+<a href="?ot=desc&amp;o=6">
+Is staff
+</a></th>''')
+            request = self.client.get(self.changelist_url + '?ot=desc&o=6')
+            self.assertContains(request, '''<th class="sorted descending">
+<a href="?ot=asc&amp;o=6">
+Is staff
+</a></th>''')
+
+
+class FunctionCustomizationTest(BaseCustomizationTest):
+    """Test old way to admin customization via functions"""
+
+    def setUp(self):
+        self.changelist_url = '%s/qwert/' % ADMIN_PFX
+
+    def test_short_description(self):
+        request = self._get_page()
+        self.assertContains(request, 'How old created')
+
+    def test_admin_order_field(self):
+        with login(self, 'root', '123'):
+            request = self.client.get(self.changelist_url)
+            self.assertContains(request, '''<th>
+<a href="?ot=asc&amp;o=4">
+How old created
+</a></th>''')
+            request = self.client.get(self.changelist_url + '?ot=asc&o=4')
+            self.assertContains(request, '''<th class="sorted ascending">
+<a href="?ot=desc&amp;o=4">
+How old created
+</a></th>''')
+            request = self.client.get(self.changelist_url + '?ot=desc&o=4')
+            self.assertContains(request, '''<th class="sorted descending">
+<a href="?ot=asc&amp;o=4">
+How old created
+</a></th>''')
+
+    def test_allow_tags(self):
+        request = self._get_page()
+        self.assertEquals(request.content.count('</strong> days</td>'), 30)
+
+    def test_boolean(self):
+        request = self._get_page()
+        self.assertEqual(request.content.count('<td><img src="/media/img/admin/icon-yes.gif" alt="True" /></td>'), 2)
+        self.assertEqual(request.content.count('<td><img src="/media/img/admin/icon-no.gif" alt="False" /></td>'), 28)
+
+
+class ListColumnCustomizationTest(BaseCustomizationTest):
+
+    def setUp(self):
+        self.changelist_url = '%s/reply/' % ADMIN_PFX
+
+    def test_short_description(self):
+        request = self._get_page()
+        # via header attr
+        self.assertContains(request, 'Part of message')
+        self.assertContains(request, 'Reply author')
+        # header is not set
+        self.assertContains(request, 'Is topic starter')
+        self.assertContains(request, 'Topic')
+        self.assertContains(request, 'Topic replies count')
+
+    def test_admin_order_field(self):
+        with login(self, 'root', '123'):
+            # default order
+            request = self.client.get(self.changelist_url)
+            self.assertContains(request, '''<th class="sorted ascending">
+<a href="?ot=desc&amp;o=3">
+Topic
+</a></th>''')
+            self.assertContains(request, '''<th>
+<a href="?ot=asc&amp;o=1">
+Part of message
+</a></th>''')
+            self.assertContains(request, '''<th>
+
+Topic replies count
+</th>''')
+            self.assertContains(request, '''<th>
+
+Is topic starter
+</th>''')
+
+            # order by 'part of message'
+            request = self.client.get(self.changelist_url + '?ot=asc&o=1')
+            self.assertContains(request, '''<th>
+<a href="?ot=asc&amp;o=3">
+Topic
+</a></th>''')
+            self.assertContains(request, '''<th class="sorted ascending">
+<a href="?ot=desc&amp;o=1">
+Part of message
+</a></th>''')
+            self.assertContains(request, '''<th>
+
+Topic replies count
+</th>''')
+            self.assertContains(request, '''<th>
+
+Is topic starter
+</th>''')
+
+            # order by 'part of message' descending
+            request = self.client.get(self.changelist_url + '?ot=desc&o=1')
+            self.assertContains(request, '''<th>
+<a href="?ot=asc&amp;o=3">
+Topic
+</a></th>''')
+            self.assertContains(request, '''<th class="sorted descending">
+<a href="?ot=asc&amp;o=1">
+Part of message
+</a></th>''')
+            self.assertContains(request, '''<th>
+
+Topic replies count
+</th>''')
+            self.assertContains(request, '''<th>
+
+Is topic starter
+</th>''')
+
+
+    def test_allow_tags(self):
+        request = self._get_page()
+        self.assertEquals(request.content.count('...</p>'), 100)
+
+    def test_boolean_icon_filter(self):
+        request = self._get_page()
+        self.assertEqual(request.content.count('<td><img src="/media/img/admin/icon-yes.gif" alt="True" /></td>'), 10)
+        self.assertEqual(request.content.count('<td><img src="/media/img/admin/icon-no.gif" alt="False" /></td>'), 90)
+
+    def test_value_map(self):
+        request = self._get_page()
+
+        x = [0, 12, 22, 12, 24, 30]
+
+        self.assertEqual(request.content.count('<td>5</td>'), x[5])
+        self.assertEqual(request.content.count('<td>4</td>'), x[4])
+        self.assertEqual(request.content.count('<td>3</td>'), x[3])
+        self.assertEqual(request.content.count('<td>2</td>'), x[2])
+        self.assertEqual(request.content.count('<td>1</td>'), x[1])
+
+        self.assertEqual(request.content.count('<td>popular topic</td>'), x[5])
+        self.assertEqual(request.content.count('<td>(None)</td>'), x[4])
+        self.assertEqual(request.content.count('<td>not good</td>'), x[3])
+        self.assertEqual(request.content.count('<td>has another one</td>'), x[2])
+        self.assertEqual(request.content.count('<td>this one</td>'), x[1])
+
Index: tests/regressiontests/admin_listcolumn/models.py
===================================================================
--- tests/regressiontests/admin_listcolumn/models.py	(revision 0)
+++ tests/regressiontests/admin_listcolumn/models.py	(revision 0)
@@ -0,0 +1,62 @@
+from django.db import models
+from django.contrib.auth.models import User
+from datetime import datetime
+from django.contrib import admin as adm
+from admin import *
+
+__all__ = ['Topic', 'Reply', 'Qwert']
+
+
+class Topic(models.Model):
+    title = models.CharField(max_length=25)
+    body = models.TextField()
+    author = models.ForeignKey(User, related_name="topic_set")
+
+    class Meta:
+        ordering = ['title', ]
+
+    def __unicode__(self):
+        return self.title
+
+    def replies_count(self):
+        return self.reply_set.count()
+
+    def html_replies_count(self):
+        c = self.replies_count()
+        if c > 3:
+            return u'<strong>%s</strong>' % c
+        else:
+            return u'<i>%s</i>' % c
+    html_replies_count.allow_tags = True
+    html_replies_count.short_description = u'Replies count'
+
+    def has_replies(self):
+        return self.replies_count() > 0
+    has_replies.boolean = True
+
+    def is_staff(self):
+        return self.author.is_staff
+    is_staff.admin_order_field = 'author__is_staff'
+
+
+class Reply(models.Model):
+    topic = models.ForeignKey(Topic, related_name="reply_set")
+    author = models.ForeignKey(User, related_name="reply_set")
+    message = models.TextField()
+
+    class Meta:
+        ordering = ['topic', ]
+
+    def __unicode__(self):
+        return "%s...</p>" % self.message[:100]
+
+
+class Qwert(models.Model):
+    date = models.DateField(default=datetime.today)
+    created = models.DateTimeField(auto_now_add=True)
+    time = models.TimeField(default=datetime.now)
+
+
+adm.site.register(Topic, TopicAdmin)
+adm.site.register(Reply, ReplyAdmin)
+adm.site.register(Qwert, QwertAdmin)
Index: tests/regressiontests/admin_listcolumn/urls.py
===================================================================
--- tests/regressiontests/admin_listcolumn/urls.py	(revision 0)
+++ tests/regressiontests/admin_listcolumn/urls.py	(revision 0)
@@ -0,0 +1,6 @@
+from django.conf.urls.defaults import *
+from django.contrib import admin
+
+urlpatterns = patterns('',
+    (r'^admin/', include(admin.site.urls)),
+)
Index: tests/urls.py
===================================================================
--- tests/urls.py	(revision 14188)
+++ tests/urls.py	(working copy)
@@ -41,4 +41,7 @@
 
     # special headers views
     (r'special_headers/', include('regressiontests.special_headers.urls')),
+    
+    # admin ChangeList customization with ListColumn tests
+    (r'admin_listcolumn/', include('regressiontests.admin_listcolumn.urls')),
 )
